/*********************************************
Project : Commande de l'antenne (TP2)
Version : 1
Mise  jour: 28/10/2010
Author  : Philippe Mariano
Company : LYCEE Pierre Emile MARTIN
Comments: La commande de l'antenne est
mmorise par les BP S1, S2, S3 et S4
Cible: Systme Antenne parabolique
Chip type           : ATMEGA8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>
// -----------------------------------------------------------------------------------------------------
// Etats du graphe des transitions
// -----------------------------------------------------------------------------------------------------
#define Arret	        0
#define Horaire 	    1
#define AntiHoraire     2
// -----------------------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>
// -----------------------------------------------------------------------------------------------------
// =====================================================================================================
// Programme principal
// =====================================================================================================
void main(void)
{  // Dbut prog principal
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------
// type 	nom              		Description
// -----------------------------------------------------------------------------------------------------
unsigned char BP, Moteur, Etat;
// -----------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
//					Configuration des ports d'E/S
//-------------------------------------------------------------------------------------------------------
// Port A initialization
PORTA=0x3F; 		        // ne pas modifier cette valeur
DDRA=0x00;

// Port B initialization
PORTB=0x00;                 // ne pas modifier cette valeur
DDRB=0x1f;
//-------------------------------------------------------------------------------------------------------
// Initialisation du graphe et des sorties
Etat = Arret; Moteur = 0;
// =====================================================================================================
// Boucle principale
// =====================================================================================================
while(1)  // Rpter toujours
 {

   BP = (PINA & 0b00011110);   // Lecture des entres. Pour mmoire: O 0 0 0 S4 S2 S3 S1 0

   switch (Etat) // dbut selon
   { // Etat Arret
     case Arret: Moteur = 0;
               if (BP == 2)	Etat = Horaire;
                    else if (BP == 4)	Etat = AntiHoraire;
                        else Etat = Arret;
     break;

     // Etat Descendre
     case Horaire: Moteur = 1;  	                     // <-   complter
                if (BP == 8) Etat= Arret;		  	     // <-   complter
      		        else Etat = Horaire;                 // <-   complter
     break;

     // Etat Monter
     case AntiHoraire: Moteur = 2;                      // <-   complter
      		if (BP == 16)	Etat = Arret;               // <-   complter
      		        else Etat = AntiHoraire;	        // <-   complter
     break;

     default : Etat = Arret;
    } // fin selon

    PORTC = Moteur;
//-------------------------------------------------------------------------------------------------------
 };// fin rpter toujours
 //-------------------------------------------------------------------------------------------------------
}// fin prog principal
// =====================================================================================================